global HAND_CURSOR, GRAB_CURSOR, MAX_FACE_PIECES, GRAB_CH, PREV_FACE_CH, NEXT_FACE_CH, grectPosterArea, gnNumPieces

on mouseEnter
  cursor([HAND_CURSOR, HAND_CURSOR + 1])
end

on mouseLeave
  cursor(0)
end

on mouseDown me
  cursor([GRAB_CURSOR, GRAB_CURSOR + 1])
  set nSound to PickupSound(me, 0)
  set the mouseDownScript to "DontPassEvent"
  FirstSticker(me, nSound)
  repeat while OnPoster()
    MidiLoop()
    Stickers(me, nSound)
  end repeat
  set the member of sprite GRAB_CH to member "NullCast"
end

on OnPoster
  if inside(point(the mouseH, the mouseV), grectPosterArea) then
    if rollOver(PREV_FACE_CH) or rollOver(NEXT_FACE_CH) then
      return 0
    else
      return 1
    end if
  else
    return 0
  end if
end

on FirstSticker me, nSound
  set the member of sprite GRAB_CH to the member of sprite the spriteNum of me
  set the loc of sprite GRAB_CH to point(the mouseH, the mouseV)
  updateStage()
  repeat while not (the mouseDown)
    MidiLoop()
    set the loc of sprite GRAB_CH to point(the mouseH, the mouseV)
    updateStage()
  end repeat
  dontPassEvent()
  repeat while the mouseDown
    MidiLoop()
    set the loc of sprite GRAB_CH to point(the mouseH, the mouseV)
    updateStage()
  end repeat
  dontPassEvent()
  if gnNumPieces < MAX_FACE_PIECES then
    if OnPoster() then
      PlaceSound(nSound)
      AddToFace()
    else
      repeat while not (the mouseDown)
        set the loc of sprite GRAB_CH to point(the mouseH, the mouseV)
        updateStage()
      end repeat
      dontPassEvent()
    end if
  else
    puppetSound(1, "sndMaxPieces")
  end if
end

on Stickers me, nSound
  set the member of sprite GRAB_CH to the member of sprite the spriteNum of me
  set the loc of sprite GRAB_CH to point(the mouseH, the mouseV)
  updateStage()
  repeat while not (the mouseDown) and OnPoster()
    set the loc of sprite GRAB_CH to point(the mouseH, the mouseV)
    updateStage()
  end repeat
  dontPassEvent()
  if not OnPoster() then
    set the member of sprite GRAB_CH to member "NullCast"
    cursor([HAND_CURSOR, HAND_CURSOR + 1])
  else
    repeat while the mouseDown and OnPoster()
      MidiLoop()
      set the loc of sprite GRAB_CH to point(the mouseH, the mouseV)
      updateStage()
    end repeat
    dontPassEvent()
    if not OnPoster() then
      set the member of sprite GRAB_CH to member "NullCast"
      cursor([HAND_CURSOR, HAND_CURSOR + 1])
    else
      if gnNumPieces < MAX_FACE_PIECES then
        PlaceSound(nSound)
        AddToFace()
      else
        puppetSound(1, "sndMaxPieces")
      end if
    end if
  end if
end
